import Ares from './http_ares';
import RNRender from './rn_render';
import DeviceInfo from 'react-native-device-info';
import { Platform } from 'react-native';
import BackgroundTimer from 'react-native-background-timer';


//是否处于更新
var isUpgrade = false;

var UpgradeAppTimerId = null;

export function clearQMUpgradeTimer() {
    if (UpgradeAppTimerId) {
      BackgroundTimer.clearTimeout(UpgradeAppTimerId);
  }
}

export function QMUpgradeTimer(seconds, pid, eid, svid, bundleVer, progressFunc) {
  UpgradeAppTimerId =  BackgroundTimer.setInterval(() => {
    QMUpgrade(pid, eid, svid,  bundleVer, progressFunc);
  }, 1000 * seconds);
}

export function QMUpgrade(pid, eid, svid, bundleVer, progressFunc) {
  if (isUpgrade) {
    return;
  }
  isUpgrade = true;
  //APP升级
  Ares.Upgrade_App({
    pid: pid,
    versionCode: DeviceInfo.getBuildNumber(),
    platform: 'android' === Platform.OS ? 'a' : 'i'
  }, progress => {
    // console.log('Upgrade.Upgrade_App', progress);
    if(progressFunc) progressFunc('app',progress);
  }).then(r => {
    if (r) {
      RNRender.render();
      return;
    }
    console.log('=================================================');

    //模块升级
    return Ares.Upgrade_Bundle({
      pid: pid,
      eid: eid,
      sv: svid,
      version: bundleVer, 
      platform: 'android' === Platform.OS ? 'android' : 'ios'
    }, progress => {
      // msg.emit('VEM::UPDATE::LOADING', true);
      // console.log('Upgrade.Upgrade_Bundle', progress);
      if(progressFunc) progressFunc('bundle', progress);
    });
  }).then(r => {
    isUpgrade = false;
    if (r) {
      // msg.emit('VEM::UPDATE::LOADING', false);
      if(progressFunc) progressFunc('-', 'end');
      RNRender.render();
    }
  }).catch(e => {
    isUpgrade = false;
    if(progressFunc) progressFunc('error', 'end');
  });
}

export default {
  QMUpgrade,
  QMUpgradeTimer,
  clearQMUpgradeTimer
}