import * as React from 'react';
import { View, StyleSheet } from 'react-native';
import QMAresUpgrade from './QMAres';
import ExToast from './ex-loading-toast';

var isBeginUpdate = true;
export default class QMAresView extends React.Component {
    
    state = {
        loading: false
    }

    constructor(props) {
        super(props);
    }

    onBundleUpdate = (value) => {
        if (value != this.state.loading) {
            this.setState({ loading: value });
        }
    };

    _progress = (id, progress) => {
        if(this.props.onProgress) {
            this.props.onProgress(id, progress);
        }
        this.onBundleUpdate(true);
        if (String(progress) === 'end') {
            this.onBundleUpdate(false);
        }
    }

    componentDidMount() {
        if (null == this.props.pid
            || null == this.props.eid
            || null == this.props.svid) {
            console.warn("pid/eid/svid can't NULL");
            return;
        }
        if (isBeginUpdate) {
            QMAresUpgrade.QMUpgrade(
                this.props.pid, 
                this.props.eid, 
                this.props.svid, 
                //start version
                this.props.bundle,
                //end version
                this._progress);
            isBeginUpdate = false;
        }
        //启动更新线程
        var time = null == this.props.checkUpdateTime ? 30 : this.props.checkUpdateTime;
        QMAresUpgrade.QMUpgradeTimer(
            time, 
            this.props.pid, 
            this.props.eid, 
            this.props.svid, 
            //start version
            this.props.bundle,
            //end version
            this._progress);
    }

    componentWillUnmount() {
        QMAresUpgrade.clearQMUpgradeTimer();
    }

    render() {
        var loadingView = this.props.loadingView ?
            this.props.loadingView 
         : <ExToast loading={this.state.loading} text="系统正在更新... 请勿操作！" />;
        return (React.createElement(View, { style: [styles.container, this.props.style] }, this.state.loading ? loadingView : this.props.children));
    }
}
const styles = StyleSheet.create({
    container: {
        flex: 1,
    },
});
