package com.qianmi.autoupdater;

import android.app.Application;
import android.os.Environment;
import android.text.TextUtils;
import android.util.Log;

import com.blankj.utilcode.util.FileIOUtils;
import com.facebook.react.ReactNativeHost;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import javax.annotation.Nullable;

import static com.qianmi.autoupdater.RNRenderModule.OBJECT_KEY_BUNDLE_FILE;


/**
 * Created by xiayinglin on 2017/9/24.
 */
public abstract class ReloadReactNativeHost extends ReactNativeHost {


    public ReloadReactNativeHost(Application application) {
        super(application);
    }


    @Nullable
    @Override
    protected String getJSBundleFile() {
        //从asyncStroage中获取升级版本信息
//        ReactDatabaseSupplier mReactDataSupplier = ReactDatabaseSupplier.getInstance(getApplication());
//        String data = AsyncLocalStorageUtil.getItemImpl(mReactDataSupplier.get(), BUNDLE_APK_URI_STORAGE_KEY);
//        Map<String, String> map = RNRenderModule.toData(data);

        Map<String, String> map = getVersion();
        String url = map.get(OBJECT_KEY_BUNDLE_FILE);
        Log.d(getClass().getSimpleName(), "ReloadReactNativeHost.getJSBundleFile ->:" + url);
        return url;
    }


    public abstract String getPackageName();


    public Map<String, String> getVersion() {
        File externalStorageDirectory = Environment.getExternalStorageDirectory();
        String path = externalStorageDirectory != null ? externalStorageDirectory.getAbsolutePath()
                : getApplication().getFilesDir().getAbsolutePath();
        return toData(FileIOUtils.readFile2String(new File(path, "version.json")));
    }


    public static Map<String, String> toData(String data) {
        if (TextUtils.isEmpty(data)) {
            return new HashMap<>();
        } else {
            GsonBuilder gb = new GsonBuilder();
            Gson g = gb.create();
            return g.fromJson(data, new TypeToken<Map<String, String>>() {
            }.getType());
        }
    }

}
