import * as React from 'react';
import { StyleSheet, View, Text, ActivityIndicator } from 'react-native';
import { Dimensions } from 'react-native';


let deviceHeight = Dimensions.get('window').height;
let deviceWidth = Dimensions.get('window').width;
let widthRatio = deviceWidth / 1080;
let font28 = 28 * widthRatio;
const radiusBase = 8;


export default class ExToast extends React.Component {
    render() {
        const { text } = this.props;
        return (this.props.loading ? React.createElement(View, { style: styles.toastWrap },
            React.createElement(ActivityIndicator, { animating: true, style: { marginRight: 10 }, color: "#fff", size: "large" }),
            React.createElement(Text, { style: { fontSize: font28, color: '#fff' } }, text)) : null);
    }
}
ExToast.defaultProps = {
    text: '天干物燥，小心上火～',
    loading: false,
};
const styles = StyleSheet.create({
    toastWrap: {
        position: 'absolute',
        top: '50%',
        left: '50%',
        width: 550 * widthRatio,
        transform: [
            {
                translateX: -275 * widthRatio
            },
            { translateY: -52 * widthRatio }
        ],
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'center',
        padding: 20,
        backgroundColor: 'rgba(0,0,0,.6)',
        borderRadius: radiusBase
    }
});
